SystemOrganization addCategory: #SWA014!

Object subclass: #SWA014Upgrade
	instanceVariableNames: 'upgradeOwner cooling cooldown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

SWA014Upgrade subclass: #SWA014NullUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014NullUpgrade methodsFor: 'starting up' stamp: 'MV 1/7/2017 15:16'!
activateUpgrade
 "This class should do nothing"! !

SWA014Upgrade subclass: #SWA014SpeedboostUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014SpeedboostUpgrade methodsFor: 'starting up' stamp: 'MV 1/13/2017 10:30'!
activateUpgrade
	self cooling ifFalse: [
		self upgradeOwner 
		speed: self upgradeOwner speed + 10;
		futureDo: #speed: at: 1000 args: (Array with: (self upgradeOwner speed - 10));
		yourself.
		
		self
			cooling: true;
			futureDo: #cooling: at: (self cooldown) args: (Array with: false);
			yourself].! !

SWA014Upgrade subclass: #SWA014TrapUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014TrapUpgrade methodsFor: 'starting up' stamp: 'MV 1/13/2017 01:48'!
activateUpgrade
 	self cooling ifFalse: [
		self
			spawnTrap;
			cooling: true;
			futureDo: #cooling: at: (self cooldown) args: (Array with: false);
			yourself].! !

!SWA014TrapUpgrade methodsFor: 'world manipulation' stamp: 'MV 1/13/2017 01:08'!
spawnTrap
	|aTrap|
	aTrap := SWA014Trap new.
	aTrap swaworld: self upgradeOwner swaworld.
	aTrap center: self upgradeOwner center - (self upgradeOwner direction * self upgradeOwner bodysize).
	self upgradeOwner swaworld addMorph: aTrap.
! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'Tc 1/6/2017 16:26'!
activateUpgrade
	"The different Upgrades should overwrite this. This method gets called, when the player wants to use an Upgrade."
	self SubclassResponsibility.
	! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:50'!
cooldown
	^ cooldown.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:50'!
cooldown: aTime
	cooldown := aTime.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:41'!
cooling
	^ cooling.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:41'!
cooling: aBoolean
	cooling := aBoolean.! !

!SWA014Upgrade methodsFor: 'initialization' stamp: 'MV 1/13/2017 01:51'!
initialize
	super initialize.
	
	self 
		cooling: false;
		cooldown: 10000;
		yourself.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:58'!
upgradeOwner
	^upgradeOwner.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:58'!
upgradeOwner: aLivingThing
	upgradeOwner := aLivingThing.! !

CircleMorph subclass: #SWA014Food
	instanceVariableNames: 'bodysize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Food commentStamp: 'Tc 1/6/2017 16:24' prior: 0!
Zur Zeit nicht verwendet aus Performancegründen!

!SWA014Food class methodsFor: 'as yet unclassified' stamp: 'Tc 12/31/2016 14:49'!
newWithSize: aSize		
	^self new
		bodysize: aSize;
		extent: aSize asPoint;
		color: Color yellow;
		yourself.
		! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize 
	^bodysize.! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize: aSize
	bodysize := aSize.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed id direction world currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed realCenter upgradeList collisionObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Blob
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Blob commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Blob methodsFor: 'initialization' stamp: 'MV 1/3/2017 01:07'!
initialize
	super initialize.
	self speed: 3.0.! !

!SWA014Blob methodsFor: 'constants' stamp: 'Tc 1/13/2017 14:24'!
isBlob
 	^true.! !

!SWA014Blob methodsFor: 'movement' stamp: 'MV 1/3/2017 00:34'!
moveAutomatically
	self swaworld realCenter: self swaworld realCenter - (self speed * self direction).
	self swaworld refreshCenter.
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014Blob methodsFor: 'movement' stamp: 'Tc 12/31/2016 15:38'!
movementConstant
	^3! !

!SWA014Blob methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Blob methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Blob methodsFor: 'override' stamp: 'MV 1/13/2017 00:16'!
step
	super step.
	
	self 
		calculateMovement: (self calculateRealCenterFor: World activeHand center);
		moveAutomatically;
		yourself.! !

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:39'!
bigNumber
	^SmallInteger maxVal.! !

!SWA014Enemy methodsFor: 'movement' stamp: 'MV 1/13/2017 00:22'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target realCenter.
	self < target ifTrue: [self direction: self direction negated].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'MV 1/7/2017 15:15'!
nearestEnemy
	|smallestDistance nearestEnemyobject currentDistance|
	
	smallestDistance := self bigNumber.
	nearestEnemyobject := self.
		
	self swaworld listOfLivingThings do: [:enemy| 
		currentDistance := self distanceTo: (enemy realCenter).
		currentDistance  < smallestDistance ifTrue: [
			smallestDistance := currentDistance.
			nearestEnemyobject := enemy]]
	without: self.

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'MV 1/7/2017 15:14'!
step
	"Zur Zeit wurde die Idee Geschwindigkeiten anzupassen an die Körpergröße. Der Code ist nur auskommentiert und nicht gelöscht, damit wir gegebenenfalls zu ihm zurückkehren können. Auch wenn dieser Code sehr warscheinlich am Ende doch verworfen wird."
	"self currentStep > self stepNumber
		ifTrue: ["
			self 
				calculateMovement: self nearestEnemy;
				moveAutomatically;
				currentStep: 0;
				yourself"] 
		ifFalse: [self currentStep: self currentStep + 1]".
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:37'!
< aLivingThing
	^self bodysize < aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:39'!
> aLivingThing
	^self bodysize > aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 21:39'!
addMassOf: aLivingThing
	self bodysize: 2 * ((self squaredRadius + aLivingThing squaredRadius) sqrt).! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 12/16/2016 12:09'!
bodysize: x
	x < (self maxAllowedSize)
		ifTrue: [
			x > (self minAllowedSize) 
				ifTrue: [	bodysize := x]
				ifFalse: [bodysize := self minAllowedSize]]
		ifFalse: [bodysize := self maxAllowedSize].
	! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'Tc 1/20/2017 11:37'!
bodysize: aSize
	oldBodysize: self bodysize.
	aSize < (self maxAllowedSize)
		ifTrue: [
			aSize > (self minAllowedSize) 
				ifTrue: [	bodysize := aSize]
				ifFalse: [bodysize := self minAllowedSize]]
		ifFalse: [bodysize := self maxAllowedSize].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/12/2017 22:30'!
calculateMovement: target
	|directionVector distance|
	
	distance := target dist: self realCenter.
	distance = 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	
	directionVector := (target - self realCenter) / distance.
	self direction: directionVector.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/13/2017 01:04'!
calculateRealCenterFor: aPosition
	self flag: 'TODISCUSS: In welche Klasse gehört diese Methode?'.
	^aPosition - self swaworld realCenter + self swaworld radius asPoint.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/7/2017 15:49'!
checkForCollisions
	self 
		checkForCollisionsWithLivingThings;
		"checkForCollisionsWithFood;" "Zur Zeit ist food nicht aktiv, deswegen ist es nicht nötig auf Kollisionen zu prüfen"
		yourself.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/13/2017 00:17'!
checkForCollisionsWithFood
	self swaworld listOfFood do: [:eatable|
		(self distanceTo: (self calculateRealCenterFor: eatable center)) < self squaredRadius ifTrue: [
			self eat: eatable]].! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/12/2017 22:40'!
checkForCollisionsWithLivingThings
	self swaworld listOfLivingThings do: [:enemy|
		(self checkForOverlapWith: enemy) ifTrue: [
			enemy < self 
				ifTrue: [	enemy goBehind.
						(self distanceTo: enemy realCenter) < self squaredRadius ifTrue: [
							self eat: enemy]] 
				ifFalse: [enemy comeToFront].
			self swaworld image goBehind]] without: self.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/10/2016 14:04'!
checkForOverlapWith: enemy
	^(self bottom > enemy top and: 
	    self top < enemy bottom and:
	    self left < enemy right and:
	    self right > enemy left).
! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 15:21'!
collisionObject
	^collisionObject.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 15:21'!
collisionObject: anObject
	collisionObject := anObject.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/12/2017 22:31'!
distanceTo: enemy
	^((enemy x - self realCenter x) squared) +
	 ((enemy y - self realCenter y) squared). "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/12/2017 22:01'!
eat: prey
	self addMassOf: prey.

	self swaworld listOfEnemies remove: prey ifAbsent: [].
	self swaworld listOfFood remove: prey ifAbsent: [].
	
	prey isBlob not
 		ifTrue: [	prey delete.
				self swaworld game spawnEnemy. ]
		ifFalse: [self swaworld game gameOver].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'MV 1/7/2017 14:28'!
initialize
	super initialize.
	
	self 
		maxAllowedSize: 1000;
		maxAllowedSpeed: 1000;
		minAllowedSize: 10;
		minAllowedSpeed: 0;
		currentStep: 0;
		speed: 2.0;
		direction: 0.0 asPoint;
		borderWidth: 2; "these initial values don't change at runtime"
		upgradeList: Dictionary new;
		yourself.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 1/12/2017 19:45'!
isBlob
	^false.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSize
	^maxAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize: aNumber
	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSpeed
	^maxAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:12'!
maxAllowedSpeed: aNumber
	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
minAllowedSize
	^minAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:33'!
minAllowedSize: aNumber
	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:36'!
minAllowedSpeed
	^minAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:13'!
minAllowedSpeed: aNumber
	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/3/2017 00:33'!
moveAutomatically
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 21:29'!
radius
	^self bodysize/2.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:29'!
realCenter
	^realCenter.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:30'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 16:15'!
refreshCenter
	self center: self swaworld realCenter - ((self swaworld width / 2)@(self swaworld height / 2)) + self realCenter.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/16/2016 15:48'!
speed: x
	x < self maxAllowedSpeed 
		ifTrue: [
			x> (self minAllowedSpeed) 
			ifTrue: [speed := x]
			ifFalse: [speed := self minAllowedSpeed]]
		ifFalse: [speed := self maxAllowedSpeed].
	! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:31'!
squaredRadius
	"Der Radius wird Quadriert, damit wir, wenn wir mit ihm vergleichen, keine Wurzel ziehen müssen (Phytagoras)"
	^self radius squared. ! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 1/7/2017 14:27'!
step
	self checkForCollisions.
	
	self	refreshSize;
		"refreshCenter;"
		yourself.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'Tc 12/31/2016 15:34'!
stepNumber
	"This is used to keep the stepTime up to date"
	self flag: 'Zur Zeit nicht verwendeet und auch verhaltenstechnisch als (leicht) fehlerhaft anzusehen'.
	
	^self speed ~= 0
	   	ifTrue: [	10 * self bodysize / self speed]
		ifFalse: [SmallInteger maxVal. "Stepping very slow"].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/21/2016 19:03'!
stepTime
	^1.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:38'!
upgradeList
	^upgradeList.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:37'!
upgradeList: aList
	upgradeList := aList.! !

CircleMorph subclass: #SWA014Trap
	instanceVariableNames: 'swaworld scalingFactor preySpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Trap methodsFor: 'collision handling' stamp: 'MV 1/13/2017 00:55'!
checkForCollisionsWithLivingThings
	self swaworld listOfLivingThings do: [:aLivingThing|
		(aLivingThing distanceTo: (aLivingThing calculateRealCenterFor: self center)) < aLivingThing squaredRadius ifTrue: [
			self collideWith: aLivingThing]].! !

!SWA014Trap methodsFor: 'collision handling' stamp: 'MV 1/13/2017 01:37'!
collideWith: aLivingThing
	self inflictAilmentTo: aLivingThing.
	self futureDo: #removeAilmentOf: at: 5000 args: (Array with: aLivingThing).
	self delete.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'MV 1/13/2017 00:48'!
inflictAilmentTo: aLivingThing
	aLivingThing bodysize: aLivingThing bodysize / self scalingFactor.
	self preySpeed: aLivingThing speed.
	aLivingThing speed: 0.! !

!SWA014Trap methodsFor: 'initialization' stamp: 'MV 1/13/2017 00:49'!
initialize
	super initialize.
	self 
		color: Color blue;
		extent: 15 asPoint;
		scalingFactor: 1.5;
		yourself.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:47'!
preySpeed
	^ preySpeed.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:48'!
preySpeed: aSpeed
	preySpeed := aSpeed.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'MV 1/13/2017 00:49'!
removeAilmentOf: aLivingThing
	aLivingThing speed: self preySpeed.
	aLivingThing bodysize: aLivingThing bodysize * self scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:43'!
scalingFactor
	^ scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:43'!
scalingFactor: aFactor
	scalingFactor := aFactor.! !

!SWA014Trap methodsFor: 'override' stamp: 'MV 1/13/2017 01:09'!
step
	self checkForCollisionsWithLivingThings.! !

!SWA014Trap methodsFor: 'override' stamp: 'MV 1/13/2017 01:10'!
stepTime
	^100.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/7/2017 14:58'!
swaworld
	^ swaworld.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/7/2017 14:58'!
swaworld: anWorld
	swaworld := anWorld.! !

Morph subclass: #SWA014Game
	instanceVariableNames: 'world maxSize numberOfEnemies foodSize amountOfFood'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'Tc 1/13/2017 14:46'!
open
	self flag: 'TODO: Here is some code commented out: Decide what to do with it later'.
	^self new spawnPlayer; openHighscoreWindow; "spawnEnemy;" "spawnFood;" openInWorld; yourself.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood
	^amountOfFood.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood: anAmount
	amountOfFood := anAmount.! !

!SWA014Game methodsFor: 'upgrade managment' stamp: 'MV 1/13/2017 09:10'!
enableSpeedboostFor: aLivingThing
	|anUpgrade anAssociation|
	anUpgrade := SWA014SpeedboostUpgrade new.
	anUpgrade upgradeOwner: aLivingThing.
	anAssociation := Association new key: #Speedboost value: anUpgrade.
	aLivingThing upgradeList add: anAssociation.
	
	self flag: 'TODO: enable methoden sehen alle fast identisch aus. zusammenfassen!!'.! !

!SWA014Game methodsFor: 'upgrade managment' stamp: 'MV 1/3/2017 02:35'!
enableTrapFor: aLivingThing
	|anUpgrade anAssociation|
	anUpgrade := SWA014TrapUpgrade new.
	anUpgrade upgradeOwner: aLivingThing.
	anAssociation := Association new key: #Trap value: anUpgrade.
	aLivingThing upgradeList add: anAssociation.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize
	^foodSize.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize: aSize
	foodSize := aSize.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 12/16/2016 11:35'!
gameOver
	self delete.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/13/2017 09:13'!
handleKeystroke: anEvent
	|keyValue|
	keyValue := anEvent keyValue.
	
	keyValue = 49 ifTrue: [ "Taste: 1"
		(self swaworld blob upgradeList at: #Trap ifAbsent: [SWA014NullUpgrade new]) activateUpgrade].
	keyValue = 50 ifTrue: [ "Taste: 2"
		(self swaworld blob upgradeList at: #Speedboost ifAbsent: [SWA014NullUpgrade new]) activateUpgrade].
	keyValue = 120 ifTrue: [ "Taste: x"
		self delete].
	
	Transcript show: keyValue.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:49'!
handlesMouseOver: anEvent
	^true.! !

!SWA014Game methodsFor: 'initialization' stamp: 'MV 1/12/2017 19:36'!
initialize
	super initialize.

	self 
		extent: ActiveWorld extent;
		clipSubmorphs: true;
		swaworld: SWA014World new;
		addMorph: self swaworld;
		maxSize: 75;
		foodSize: 10;
		numberOfEnemies:50;
		amountOfFood: 1000; "initial values"
		yourself.
		
		1 to: numberOfEnemies do:[:x|self spawnEnemy ]. 
		
	self swaworld game: self.
	self swaworld center: self center.
	self swaworld realCenter: self center.
	self swaworld image center: self center.
! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
maxSize
	^maxSize.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:50'!
maxSize: aSize
	maxSize := aSize.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:50'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:51'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil.! !

!SWA014Game methodsFor: 'world manipulation' stamp: 'MV 1/13/2017 02:03'!
moveBlobToCenter
	self swaworld realCenter: self swaworld realCenter + ((self swaworld blob calculateRealCenterFor: self center) - self swaworld blob realCenter).
	self swaworld refreshCenter.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:03'!
numberOfEnemies
	^numberOfEnemies.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:25'!
numberOfEnemies: aNumber
	numberOfEnemies := aNumber.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 1/13/2017 15:12'!
openHighscoreWindow
	|newHighscoreWindow|
	
	newHighscoreWindow := SWA014Highscore new. 
	newHighscoreWindow swaworld: self swaworld.
	newHighscoreWindow openInWorld.
	self addMorph: newHighscoreWindow.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 1/7/2017 14:31'!
spawnEnemy
	|enemy random r1 r2 r3|
	
	enemy := SWA014Enemy new.
	random := Random new.
	r1 := random nextInt: self swaworld width.
	r2 := random nextInt: self swaworld height.
	r3 := random nextInt: (self maxSize).
	enemy realCenter: r1@r2.
	enemy bodysize: r3.	
	enemy swaworld: self swaworld.
	enemy refreshCenter.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/20/2016 16:17'!
spawnFood
	|eatable random r1 r2|

	self flag: 'Diese Methode ist extrem ähnlich zu spawnEnemy. Wie sollten das irgendwie zusammenfassen'.
		
	1 to: (self amountOfFood)  do: [:x|	
		eatable := SWA014Food newWithSize: self foodSize.
		random := Random new.
		r1 := random nextInt: self swaworld width.
		r2 := random nextInt: self swaworld height.
		eatable center: ((r1 + self swaworld left) @ (r2 + self swaworld top)).
		self swaworld listOfFood add: eatable.
		self swaworld addMorph: eatable].! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 1/13/2017 14:43'!
spawnPlayer
	|newPlayer|
	newPlayer := SWA014Blob new.
	newPlayer color: Color red.
	newPlayer bodysize: 60.
	newPlayer realCenter: (self swaworld width / 2)@(self swaworld height / 2).
	newPlayer center: self center.
	newPlayer swaworld: self swaworld.		
	self swaworld blob: newPlayer.
	self swaworld addMorph: newPlayer.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'override' stamp: 'MV 1/13/2017 02:06'!
step
	"|missingEnemies|"
	self moveBlobToCenter.
	"missingEnemies := self numberOfEnemies - (self swaworld listOfEnemies count: [:each| true]).
	1 to: missingEnemies do: [:x|
		self spawnEnemy]."	"Auskommentiert, da das gewünschte verhalten zur Zeit bereits in LivingThing->eat implementiert ist"! !

!SWA014Game methodsFor: 'override' stamp: 'MV 1/13/2017 02:07'!
stepTime
	^5000.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'Tc 12/4/2016 21:26'!
swaworld: aWorld
	world := aWorld.! !

Morph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies listOfFood blob game realCenter image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'world content' stamp: 'MV 1/12/2017 21:12'!
blob
	^ blob.! !

!SWA014World methodsFor: 'world content' stamp: 'MV 1/12/2017 21:13'!
blob: aLivingThing
	blob := aLivingThing.! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'MV 1/12/2017 22:48'!
checkForBorderCollisions
	self listOfLivingThings do: [:enemy | 
		enemy bounds right > self bounds right ifTrue:	[
			enemy isBlob ifTrue: [
				self realCenter: (enemy bounds right - self radius)@(self realCenter y).
				self refreshCenter]. 
			enemy realCenter: (self worldSize - enemy radius)@(enemy realCenter y).
			enemy refreshCenter].
	
		enemy bounds left < self bounds left ifTrue: [
			enemy isBlob ifTrue: [
				self realCenter: (enemy bounds left + self radius)@(self realCenter y).
				self refreshCenter]. 
			enemy realCenter: (enemy radius)@(enemy realCenter y).
			enemy refreshCenter].
	
		enemy bounds top < self bounds top ifTrue: [
			enemy isBlob ifTrue: [
				self realCenter: (self realCenter x)@(enemy bounds top + self radius).
				self refreshCenter]. 
			enemy realCenter: (enemy realCenter x)@(enemy radius).
			enemy refreshCenter].
			
		enemy bounds bottom > self bounds bottom ifTrue: [
			enemy isBlob ifTrue: [
				self realCenter: (self realCenter x)@(enemy bounds bottom - self radius).
				self refreshCenter]. 
			enemy realCenter: (enemy realCenter x)@(self worldSize - enemy radius).
			enemy refreshCenter]].! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image
	^ image.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image: anImage
	image := anImage.! !

!SWA014World methodsFor: 'initialization' stamp: 'MV 1/13/2017 01:55'!
initialize
	super initialize.
		
	self 
		image: ( ImageMorph new image: (Form fromFileNamed: 'Chrysanthemum.jpg'));"Be sure, that the picture is in the resource folder with that name"
		addMorph: self image;
		listOfEnemies: Set new;
		listOfFood: Set new;
		blob: nil;
		worldSize: 1500;
		extent: self worldSize asPoint;	
		center: 0 asPoint;
		realCenter: 0.0 asPoint;
		yourself.
		! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'MV 12/22/2016 14:38'!
listOfEnemies: aList
	listOfEnemies := aList! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:39'!
listOfFood
	^ listOfFood.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/2/2017 22:57'!
listOfFood: aList
	listOfFood := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 21:15'!
listOfLivingThings
	|listOfLivingThings|
	listOfLivingThings := self listOfEnemies copy.
	listOfLivingThings add: self blob.
	^listOfLivingThings.! !

!SWA014World methodsFor: 'body transformation' stamp: 'Tc 1/13/2017 14:34'!
radius
	^worldSize / 2.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter
	^realCenter.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014World methodsFor: 'movement' stamp: 'MV 1/7/2017 15:57'!
refreshCenter
	self center: self realCenter.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'MV 12/22/2016 11:00'!
step
	self 
		checkForBorderCollisions;
		"refreshCenter;"
		yourself.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'Tc 12/2/2016 16:02'!
stepTime
	^100! !

!SWA014World methodsFor: 'body transformation' stamp: 'Tc 11/30/2016 20:31'!
worldSize
	^worldSize! !

!SWA014World methodsFor: 'body transformation' stamp: 'Tc 11/30/2016 20:32'!
worldSize: anObject
	worldSize := anObject! !

ImageMorph subclass: #SWA014Menu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Menu class methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:32'!
open
	^SWA014Menu new openInWorld.! !

!SWA014Menu methodsFor: 'initialization' stamp: 'MV 1/3/2017 01:25'!
initialize 
	super initialize.
	
	self 
		image: (Form fromFileNamed: 'Chrysanthemum.jpg'); "Be sure, that the picture is in the resource folder with the correct name"
		addMorph:  SWA014StartButton new;
		addMorph: SWA014EndButton new;
		yourself.! !

SimpleButtonMorph subclass: #SWA014EndButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EndButton methodsFor: 'initialization' stamp: 'Tc 12/31/2016 14:48'!
initialize 
	super initialize.

	self 
		label: 'End Game';
		color: Color yellow;
		center: (World width /2)@((13/25) * World height); "The position is set full out of our preferences"
		yourself.! !

!SWA014EndButton methodsFor: 'event handling' stamp: 'Tc 1/13/2017 14:33'!
mouseDown: event
	self owner delete.! !

SimpleButtonMorph subclass: #SWA014StartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StartButton methodsFor: 'initialization' stamp: 'MV 1/2/2017 23:18'!
initialize 
	super initialize.

	self 
		label: 'Start Game';
		color: Color blue;
		center: (World width /2)@((12/25) * World height);
		yourself.! !

!SWA014StartButton methodsFor: 'event handling' stamp: 'MV 12/16/2016 11:33'!
mouseDown: evt
	SWA014Game open.! !

StringMorph subclass: #SWA014Highscore
	instanceVariableNames: 'value world reachedSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/20/2017 11:33'!
alreadyReachedSize
	^reachedSize.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/20/2017 11:49'!
alreadyReachedSize: aValue
	reachedSize := reachedSize + aValue.! !

!SWA014Highscore methodsFor: 'constants' stamp: 'Tc 1/20/2017 11:40'!
fontSize
	^60.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 12:03'!
highscoreValue
	^value.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 12:03'!
highscoreValue: aValue
	value := aValue.! !

!SWA014Highscore methodsFor: 'initialization' stamp: 'Tc 1/20/2017 12:03'!
initialize 
	super initialize.
	
	self
		highscoreValue: 0;
		acceptValue: 0;
		initializeReachedSize;
		color: Color red;
		width: 500;
		height: 500;
		yourself.! !

!SWA014Highscore methodsFor: 'constants' stamp: 'Tc 1/20/2017 11:39'!
initializeBodysize
	^60.! !

!SWA014Highscore methodsFor: 'constants' stamp: 'Tc 1/20/2017 12:02'!
initializeReachedSize
	reachedSize := 0.! !

!SWA014Highscore methodsFor: 'updating' stamp: 'Tc 1/20/2017 11:54'!
setNewHighscore
	
	(((self highscoreValue + self initializeBodysize ) - self alreadyReachedSize) < self swaworld blob bodysize ) 
		ifTrue: [self highscoreValue:  ((self swaworld blob bodysize - self initializeBodysize) + self alreadyReachedSize) asInteger].
	self fontName: 'BitstreamVeraSans' size: self fontSize.
	! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 15:42'!
step
	self setNewHighscore.
	self acceptValue: value.! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 11:58'!
stepTime
	^1.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:54'!
swaworld
	^world
! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld! !

!SWA014Highscore methodsFor: 'updating' stamp: 'Tc 1/20/2017 11:52'!
updateAlreadyReachedSize
	self alreadyReachedSize: self swaworld blob bodysize.! !
